﻿namespace Telerik.Charting
{
    /// <summary>
    /// Defines the possible type for an axis.
    /// </summary>
    public enum AxisType
    {
        /// <summary>
        /// Defines the first axis. This value is coordinate-system specific.
        /// It represents the X (or the Horizontal) axis for a Cartesian coordinate system and the Value (or the Radius) axis for a Polar coordinate system.
        /// </summary>
        First,

        /// <summary>
        /// Defines the second axis. This value is coordinate-system specific.
        /// It represents the Y (or Vertical) axis for a Cartesian coordinate system and the Angle axis for a Polar coordinate system.
        /// </summary>
        Second,
    }
}
